clear();

q = 0.1;
h = 2*q;
D = 1.0;
sFA = 0.1;  //Skalar der Antriebskraft links FA
sFB = 0.2;
d = 0.05;
m = 0.3;
J = (1.0/12.0)*m*(d*d+h*h);

function f = rechteSeite(t,yy)
                         
    x = yy(1,1);
    y = yy(2,1);
    phi = yy(3,1);
    
    vx    = yy(4,1);
    vy    = yy(5,1);
    omega = yy(6,1);
             
    ex = [cos(phi);sin(phi)];
    ey = [-sin(phi);cos(phi)];
    FA = sFA*ex;
    FB = sFB*ex;
    
    //Drehmatrix:
    TT = [ex,ey];
    
    //Geschwindigkeiten in A und B:
    vekom = [0;0;omega];
    rSA = TT*[0;q];
    rSB = -rSA;
    va = [vx;vy;0] + cross(vekom,[rSA(1);rSA(2);0]);        
    vb = [vx;vy;0] + cross(vekom,[rSB(1);rSB(2);0]);        
    
    FAD = -D*va;
    FBD = -D*vb;
          
    LL = FA(1)+FAD(1)+FB(1)+FBD(1);      
    MM = FA(2)+FAD(2)+FB(2)+FBD(2);      
    
    QQ = vx*omega*cos(phi) + vy*omega*sin(phi);
                              
    sFZ = LL*sin(phi) - MM*cos(phi) + QQ*m;
    
    FZ = sFZ*ey;
                                    
    f(1,1) = vx;
    f(2,1) = vy;
    f(3,1) = omega;
    
    f(4,1) = (LL+FZ(1))/m;
    f(5,1) = (MM+FZ(2))/m;
    
    EULER = cross([rSA(1);rSA(2);0],[FA(1)+FAD(1);FA(2)+FAD(2);0]) + cross([rSB(1);rSB(2);0],[FB(1)+FBD(1);FB(2)+FBD(2);0]);
    
    f(6,1) = EULER(3)/J;
    
    
endfunction

t = linspace(0,20,1000);
y0 = [0,0,0,0,0,0]';
t0 = 0;
y  = ode(y0,t0,t,rechteSeite);

//plot(t,y(1,:),t,y(4,:));
plot(y(1,:),y(2,:));
//plot(t,y(3,:),t,y(6,:));

fd = mopen('/home/fhbstud/arbeiten/text3.txt','wt');
    mfprintf(fd,'double[][] MATRIX={\n');
for(i=1:3000)
    mfprintf(fd,'{%f, %f, %f, %f},\n',t(i),y(1,i),y(2,i),y(3,i));
end
    mfprintf(fd,'};\n');
mclose(fd);
 
