public class Par
{
    public static double SIM_BREITE =2.0;  //sichtbarer Bereich in Metern
    public static double SIM_HOEHE  =2.0;  //sichtbarer Bereich in Metern
    public static double PIXEL_PRO_METER;
    
    public static int PIXEL_BREITE; //Breite des dargestellten Bereichs in Pixeln
    public static int PIXEL_HOEHE;
    public static int PIXEL_XOFF;
    public static int PIXEL_YOFF;

    public static double x,y,phi;

    //Fahrzeugparameter:
    public static double q=0.1;   //Halbe Fahrzeug-Achsbreite
    public static double h=2.0*q; //Fahrzeug-Achsbreite
    public static double d=0.05;  //Fahrzeugtiefe/länge
    
    public static void initialisieren(int BREITE, int HOEHE)//Übergabe der Bildschirmbreite und - höhe
    {
        if((double)BREITE/SIM_BREITE > (double)HOEHE/SIM_HOEHE)
            PIXEL_PRO_METER = (double)HOEHE/SIM_HOEHE;   
        else    
            PIXEL_PRO_METER = (double)BREITE/SIM_BREITE;   
            
        PIXEL_BREITE =  (int)(0.5+PIXEL_PRO_METER*SIM_BREITE);
        PIXEL_HOEHE  =  (int)(0.5+PIXEL_PRO_METER*SIM_HOEHE);
        PIXEL_XOFF   =  (BREITE - PIXEL_BREITE)/2;
        PIXEL_YOFF   =  (HOEHE - PIXEL_HOEHE)/2;
    }
    
    public static float transX(double x) //rechnet Simulationskoordinate x in Pixeln auf dem Bildschirm um.
    {
        //Koordinatenursprung ist in der Mitte:
        x+=SIM_BREITE*0.5;
        return (float)PIXEL_XOFF + (float)(PIXEL_PRO_METER*x);
    }
    
    public static float transY(double y) //rechnet Simulationskoordinate x in Pixeln auf dem Bildschirm um.
    {
        //Koordinatenursprung ist in der Mitte:
        y+=SIM_HOEHE*0.5;
        //y-Koordinatenachse zeigt nach unten beim Bildschirm:       
        y=SIM_HOEHE-y;
        return (float)PIXEL_YOFF + (float)(PIXEL_PRO_METER*y);
    }
    
    /**
     * Liefert x,y verschobene und um phi verdrehte Koordinaten von Körperpunkten xk,yk in Bildschirmkoord.
     *
     */
    public static float ktransX(double x, double y, double phi, double xk, double yk)
    {
        return transX(x + Math.cos(phi)*xk - Math.sin(phi)*yk);
    }
    public static float ktransY(double x, double y, double phi, double xk, double yk)
    {
        return transY(y + Math.sin(phi)*xk - Math.cos(phi)*yk);
    }
    
    public static void setXYPHI(double inx, double iny, double inphi)
    {
        x=inx;
        y=iny;
        phi=inphi;
    }
    public static float ktransX(double xk, double yk)
    {
        return transX(x + Math.cos(phi)*xk - Math.sin(phi)*yk);
    }
    public static float ktransY(double xk, double yk)
    {
        return transY(y + Math.sin(phi)*xk + Math.cos(phi)*yk);
    }
}
