public class RungeKuttaIntegrator extends Integrator
{
    double[] k1,k2,k3,k4;
    double[] yk1,yk2,yk3,yk4;
    
    public RungeKuttaIntegrator(Modell modell)
    {
        super(modell);
        k1 = new double[modell.holeAnzahlGleichungen()];
        k2 = new double[modell.holeAnzahlGleichungen()];
        k3 = new double[modell.holeAnzahlGleichungen()];
        k4 = new double[modell.holeAnzahlGleichungen()];
        
        yk1 = new double[modell.holeAnzahlGleichungen()];
        yk2 = new double[modell.holeAnzahlGleichungen()];
        yk3 = new double[modell.holeAnzahlGleichungen()];
        yk4 = new double[modell.holeAnzahlGleichungen()];
        
    }

    public double[] berechneZeitschritt(double[] yalt, double t, double dt)
    {
        modell.berechneRechteSeite(yalt,t);
        for(int i=0;i<k1.length;i++)
            k1[i]=modell.getF(i);        
        for(int i=0;i<k1.length;i++)
            yk1[i] = yalt[i] + 0.5*dt*k1[i];
        
        modell.berechneRechteSeite(yk1,t+0.5*dt);
        for(int i=0;i<k2.length;i++)
            k2[i]=modell.getF(i);        
        for(int i=0;i<k2.length;i++)
            yk2[i] = yalt[i] + 0.5*dt*k2[i];
        
        modell.berechneRechteSeite(yk2,t+0.5*dt);
        for(int i=0;i<k3.length;i++)
            k3[i]=modell.getF(i);        
        for(int i=0;i<k3.length;i++)
            yk3[i] = yalt[i] + dt*k3[i];
        
        modell.berechneRechteSeite(yk2,t+0.5*dt);
        for(int i=0;i<k4.length;i++)
            k4[i]=modell.getF(i);        
        for(int i=0;i<k4.length;i++)
            yk4[i] = yalt[i] + (dt/6.0)*(k1[i]+2.0*k2[i]+2.0*k3[i]+k4[i]);
                
        return yk4;
    }
    
    public static void main(String[] args)
    {
         double t=0.0;
         double dt=0.01;
         double[] yneu;
         double[] yalt = {0.0,0.0,0.0,0.0,0.0,0.0};
         
         //RungeKuttaIntegrator ruku = new RungeKuttaIntegrator(new SchwingerModell());
         RungeKuttaIntegrator ruku = new RungeKuttaIntegrator(new AutonomesVehikel());
         
         for(int i=0;i<1000;i++)
         {
             System.out.println(t+" "+yalt[0]+" "+yalt[3]);
             
             yneu = ruku.berechneZeitschritt(yalt,t,dt);    
             for(int k=0;k<yalt.length;k++)
             {
                 //System.out.println("y["+k+"]="+yalt[k]);
                 yalt[k]=yneu[k];
             }                 
             t+=dt;
         }
    }
}
